﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;

namespace EgDDEsvr
{
    public class DdeInfo
    {
        /// <summary>
        /// DDEサーバにアクセスしてきたDDEクライアントのハンドル
        /// </summary>
        public IntPtr Handle
        {
            get { return m_Handle; }
            set { m_Handle = value; }
        }
        private IntPtr m_Handle;

        /// <summary>
        /// サービス名
        /// </summary>
        public string Service
        {
            get { return m_stService; }
            set { m_stService = value; }
        }
        private string m_stService;

        /// <summary>
        /// トピック名
        /// </summary>
        public string Topic
        {
            get { return m_sTopic; }
            set { m_sTopic = value; }
        }
        private string m_sTopic;

        /// <summary>
        /// 参照カウント
        /// NOTE: 同一ハンドルから複数接続された場合にインクリメント
        /// </summary>
        public int RefCount
        {
            get { return m_inRefCount; }
            set { m_inRefCount = value; }
        }
        private int m_inRefCount;

        /// <summary>
        /// 監視タグ
        /// NOTE: Disconnectされたときに監視タグの削除判定に利用する
        /// </summary>
        public List<string> AdviseItem
        {
            get { return m_srAdviseItem; }
            set { m_srAdviseItem = value; }
        }
        private List<string> m_srAdviseItem;

        /// <summary>
        /// 監視タグ(Adviseタグ)の追加
        /// </summary>
        /// <param name="item"></param>
        public void AddItem(string item)
        {
            if (AdviseItem == null)
            {
                AdviseItem = new List<string>();
            }
            AdviseItem.Add(item);
        }

        /// <summary>
        /// 監視タグ(Adviseタグ)の削除
        /// </summary>
        /// <param name="item"></param>
        public void DelItem(string item)
        {
            AdviseItem.Remove(item);
        }
    }
}
